!**************************************************************************
!*
!* Boot-ROM-Code to load an operating system across a TCP/IP network.
!*
!* Module:  hw/eth.inc
!* Purpose: General definitions for ethernet hardware
!* Entries: None
!*
!**************************************************************************
!*
!* Copyright (C) 1998-2003 Gero Kuhlmann <gero@gkminix.han.de>
!*
!*  This program is free software; you can redistribute it and/or modify
!*  it under the terms of the GNU General Public License as published by
!*  the Free Software Foundation; either version 2 of the License, or
!*  any later version.
!*
!*  This program is distributed in the hope that it will be useful,
!*  but WITHOUT ANY WARRANTY; without even the implied warranty of
!*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!*  GNU General Public License for more details.
!*
!*  You should have received a copy of the GNU General Public License
!*  along with this program; if not, write to the Free Software
!*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!*
!* $Id: eth.inc,v 1.5 2003/03/09 00:24:27 gkminix Exp $
!*

#ifndef _HW_ETH_INC
#define _HW_ETH_INC


!
!**************************************************************************
!
! If _USE_ASSEMBLER is not defined yet we have to include general.inc. Then
! it is possible to also include necessary C header files here.
!
#ifndef _USE_ASSEMBLER
#include <general.inc>
#endif
#include <hw/eth.h>


!
!**************************************************************************
!
! Packet types:
!
ETH_P_MIN	equ	ETH_DATA_MAX+1	! Minimum number for protocol type
ETH_P_IP	equ	$0800		! Internet Protocol packet
ETH_P_ARP	equ	$0806		! Address Resolution Protocol packet
ETH_P_RARP	equ	$8035		! Reverse Address Resolution Protocol


!
!**************************************************************************
!
#endif

