!**************************************************************************
!*
!* Boot-ROM-Code to load an operating system across a TCP/IP network.
!*
!* Module:  libpriv.inc
!* Purpose: Private include file for library modules
!* Entries: none
!*
!**************************************************************************
!*
!* Copyright (C) 1995-2003 Gero Kuhlmann <gero@gkminix.han.de>
!*
!*  This program is free software; you can redistribute it and/or modify
!*  it under the terms of the GNU General Public License as published by
!*  the Free Software Foundation; either version 2 of the License, or
!*  any later version.
!*
!*  This program is distributed in the hope that it will be useful,
!*  but WITHOUT ANY WARRANTY; without even the implied warranty of
!*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!*  GNU General Public License for more details.
!*
!*  You should have received a copy of the GNU General Public License
!*  along with this program; if not, write to the Free Software
!*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!*
!* $Id: libpriv.inc,v 1.4 2003/01/25 23:29:41 gkminix Exp $
!*

#ifndef _KERNEL_LIB_LIBPRIV_INC
#define _KERNEL_LIB_LIBPRIV_INC


!
!**************************************************************************
!
! Equates defining special ASCII characters:
!
CHR_BELL	equ	$07		! bell character
CHR_BS		equ	$08		! backspace character
CHR_TAB		equ	$09		! tab character
CHR_LF		equ	$0A		! linefeed character
CHR_FF		equ	$0C		! form feed character
CHR_CR		equ	$0D		! carriage return character
CHR_ESC		equ	$1B		! escape character
CHR_SPACE	equ	$20		! space character
CHR_COLON	equ	$21		! colon character
CHR_PERCENT	equ	$25		! percent character
CHR_EQUAL	equ	$3D		! equal sign
CHR_QUEST	equ	$3F		! question mark
CHR_BRACKET	equ	$5B		! left bracket


!
!**************************************************************************
!
! Definition of jump buffer environment
!
JMPBUF_SIZE	equ	6			! number of words in jump buffer
JMPBUF_LEN	equ	(JMPBUF_SIZE * 2)	! size of buffer in bytes

JMPBUF_SI	equ	$0000			! offset to SI
JMPBUF_DI	equ	$0002			! offset to DI
JMPBUF_BP	equ	$0004			! offset to BP
JMPBUF_SP	equ	$0006			! offset to SP
JMPBUF_ES	equ	$0008			! offset to ES
JMPBUF_PC	equ	$000A			! offset to program counter


!
!**************************************************************************
!
#endif

