.\" @(#)makerom.8
.\"
.\" Copyright (C) 1997-2003 Gero Kuhlmann   <gero@gkminix.han.de>
.\"
.\"  This program is free software; you can redistribute it and/or modify
.\"  it under the terms of the GNU General Public License as published by
.\"  the Free Software Foundation; either version 2 of the License, or
.\"  any later version.
.\"
.\"  This program is distributed in the hope that it will be useful,
.\"  but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"  GNU General Public License for more details.
.\"
.\"  You should have received a copy of the GNU General Public License
.\"  along with this program; if not, write to the Free Software
.\"  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\"
.\"  $Id: makerom.man,v 1.8 2003/03/09 00:43:08 gkminix Exp $
.TH MAKEROM 8 "20 Jun 2002"
.SH NAME
makerom \- Make bootrom image

.SH SYNOPSIS
.LP
.B makerom
[OPTIONS]

.SH DESCRIPTION
.B makerom
generates a
.B netboot
bootrom either interactively or in batch mode. It works by first concatenating
the bootrom kernel file with the network driver interface and the network
driver (like packet or NDIS driver), then compressing the resulting image
and concatenating it with either the floppy or the rom loader stubs.

.SH OPTIONS
.TP
.B \-b, \-\-batch-sys SYS
Lets
.B makerom
operate in batch mode. It will look up the given system name in a
database file and generate a bootrom according to the specifications
given in the database entry. If this option is not given,
.B makerom
will operate in interactive mode, asking the user about all required
parameters on the console.
.TP
.B \-C, \-\-config-file FILE
Specifies the pathname of the configuration file. If this option is not
given, the value of the
.SM NETBOOT_CONFIG
environment variable or a compiled-in default will be used.
.TP
.B \-d, \-\-drivers FILES
Specifies the pathname of the network driver information file. If this
option is not given, the name will be taken from the main configuration
file, or a compiled-in default will be used.
.TP
.B \-D, \-\-database\-file FILE
Pathname of database file to be used together with the
.B \-b
or
.B \-\-batch\-sys
options. If this option is not given, the value of the
.SM NETBOOT_DATABASE
environment variable or a compiled-in default will be used.
.TP
.B \-h, \-\-help
Print short usage information.
.TP
.B \-m, \-\-md5sums FILE
Specifies the path name of a file containing the MD5 checksums of the
currently installed network drivers (MD5 checksum database file).
.TP
.B \-N, \-\-netboot-dir DIR
Specifies the netboot directory where
.B makerom
looks for the files required for generating a new bootrom. If this option
is not given, the value of the
.SM NETBOOT
environment variable or a compiled-in default will be used.
.TP
.B \-v, \-\-version
Print version information.
.TP
.B \-x, \-\-verbose
Increase verbosity level.

.SH INTERACTIVE MODE
When no
.B \-b
or
.B \-\-batch\-sys
option has been specified on the command line,
.B makerom
will operate in interactive mode. It will ask for all the
information necessary to build a bootrom for the target client.
Of course it will only ask those questions which are really
required for proper operation of the bootrom.
Most questions have a list of allowed values given in round
brackets. The default answer, which will be taken when you just
press enter, is printed in square brackets.

.SS Build bootrom for a processor older than 386 (y/n) [no] ?
.B makerom
can build a bootrom for 16- and 32-bit x86 processors. If you are
using a processor older than a 386 (for example 8088 or 80286) you
should answer "y" to this question, since the 32-bit version will not
run on a pre-386. However, the 16-bit version will of course also run
on 32-bit processors, but it is larger and slower than the 32-bit
version.

.SS Include support for old-style menus (not recommended) (y/n) [no] ?
In earlier versions of
.B netboot
the bootrom was able to support a boot menu specified by various tags in
the BOOTP or DHCP configuration file on the server. The present version
of
.B netboot
still supports this feature, but it is highly recommended to NOT use
it, because it is quite inflexible and will probably no longer be supported
by a forthcoming version. It is better to define menus using
.BR mknbi\-mgl .
Therefore, the default answer to this question is "no". This feature is
only available with the 32-bit version of the bootrom.

.SS Do you want the BIOS to look for boot disks (y/n) [no] ?
The
.B netboot
bootrom can hook interrupt 18h or 19h. The latter will be called by
the client BIOS
.B before
it scans for boot disks (like a floppy or hard disk) in the system,
while the first interrupt will be called
.B after
this disk scan when no bootable operating system has been found on a
local disk. When you answer "no" to this question,
.B makerom
will generate the bootrom so that it will use interrupt 19h. Otherwise,
the bootrom will use interrupt 18h.
.LP
With the interrupt 19h method the bootrom will look for a boot sector
on the A: driver floppy by itself, therefore simulating some of the
BIOS boot functionality, before starting the netbooting process. This
feature can be used to start the system in case something is wrong
with the bootrom itself.
.LP
The answer to this question only matters if your client BIOS does not
support the BIOS Boot Specification (BBS), which is part of the PnP BIOS
specification. If the BBS is supported, you can select the boot order
including the network boot from within the BIOS setup, and the BIOS will
determine by itself if and when to start the
.B netboot
bootrom.

.SS Do you want the bootrom to ask before booting from network (y/n) [no] ?
This question will only appear when you answered "no" to the previous
question and therefore selected the interrupt 19h booting mechanism. If
you answer "yes" to this question, the bootrom will lateron (at runtime)
ask the user, if the network booting process should really be started. If
the user then selects "no" the bootrom will return to the BIOS so that it
can continue with it's normal disk scan for an operating system. The network
booting process will only be started if the user answers "yes" at runtime.

.SS How many seconds should the bootrom wait asking (0 = forever) [0] ?
With this question you can select how long the bootrom should wait for
a user to press a key. It will only appear if you selected "yes" at the
previous question. If you answer "0", the bootrom will wait forever for
an answer. If the bootrom times out waiting for a key press, the default
answer is to boot from a local disk and not from the network.

.SS List of network drivers
Following these questions,
.B makerom
prints a list of known network cards. This list will be generated by
using the information in the netboot.drivers(5) network information database
file. However, a network card will only appear in this list if
.B makerom
can really find at least one network driver suitable for that card. Therefore,
if you didn't put your manufacturer provided network driver into one of
the standard network driver directories
.B //netdrvr/[pktdrvr|ndis|undi]
or your driver is not included in the network information database file,
then it will not appear in this list.
.LP
You can scroll through this list by pressing enter. If you find your
network card in this list, you should remember it's number printed in the
first column of the listing. In case, your network card is not listed,
or you want to use a different network driver which
.B makerom
doesn't know about, you should use
.BR 0 ,
which stands for "unknown network card or user supplied driver". Try to
find a description in the list which matches your network card as exactly
as possible. For example, Accton builds the same network card (EN1207D)
with three different chipsets. Also, some network cards use different
PCI manufacturer and/or device IDs even when they have the same name or
use the same chipset. Another example are the WD80?3 cards, initially
manufactured by Western Digital, and later produced by SMC. Some cards
are jumper configured (for which all drivers are unable to determine the
hardware parameters themselves), and some are software configurable. You
have to select exactly the card you are using.

.SS Select a network card (-1 to review the list) [-1]:
Now enter the number for your network card. If it's not in the list,
just enter 0 as explained above. You can review the whole list by
entering -1 at this prompt. Once you entered a known network card,
.B makerom
will print it's name again for your information. It will then continue
asking you details about your network card. Most of the following questions
should already be answered by the data found in the network information
database file. However, if there is some parameter not found in the
databae for your card, you will now have to enter it.

.SS Select the bus type of your network card [1]:
At this prompt, you should enter the type of bus interface used by your
network card. If your card is Plug-and-Play compatible and not PCI, select
1 for ISA (which is the default).

.SS Select a driver [x]:
When you selected a pre-known network card,
.B makerom
will automatically use it's network driver, if it could only find one
driver. But when more than one driver could be found, it prints a description
for each driver it could find. In that case, select the driver you want
to use. The default for this question is for the driver with the least
number of parameters required for configuration, and/or the smallest
driver available.

.SS Enter network driver options:
Some network drivers need some information about the hardware they are
going to run on.
.B makerom
asks you only about those information really necessary for the selected
driver. This can include:
.TP
.B Hardware IRQ number (decimal):
The hardware interrupt number used by the network driver, ranging from
2 to 15.
.TP
.B I/O address (hex):
The I/O port address in hex. Note that for PnP cards (which have to
be configured by the BIOS, BTW, since the bootrom can't do it)
this number may be changing when changing somehing else in
the system.
.TP
.B Shared memory address (hex):
Some network cards use shared RAM for storing incoming packets. This
parameter specifies the base segment (not physical address!) of this
memory. For example, if your network card uses D8000 as its shared
memory base, enter D800 here (a segment is the physical address shifted
to the right by four bits).
.TP
.B DMA number
For some network cards it's necessary to specify a DMA channel number.
This can range from 0 to 7.
.TP
.B AUI type
This parameter is only necessary for network cards which have multiple
physical network connectors, and for which the driver is unable to
detect the used connector by itself. The meaning of this parameter
depends on the driver used. The numbers can range from -1 to +1, with
-1 meaning "default".

.SS Enter PnP device ID string (maybe empty):
Each PnP card (either for ISA, EISA or MCA bus) has a unique identifier
assigned to it by the manufacturer. Unfortunately, there is no easy way
to find out this ID. It can sometimes be found in some Windows configuration
files distrubuted together with your network card. However, this parameter
is only necessary for some BIOSes to select the boot order when using BBS.
If you are unable to determine the PnP ID of your card, try to leave this
field empty. The PnP ID consists of a 7 character string, with the first
3 characters being upper case letters, and the last 4 character representing
a hexadecimal number, like "PNP807D", for example.

.SS Enter PCI vendor ID (hex):
This question will only be printed for PCI network cards. You have to
enter the card's vendor ID here. For example, Intel chipsets use the
number 8086, but beware: Intel also builds network cards with chipsets
not built by them (for example, Intel has recently included the Digital
chipsets into their product line), so you should not simply guess a number
from the manufacturer of your card. If you don't know the vendor ID for
your network card, try using a system information tool like AGSI, which
prints these ID's. Also, Ralf Brown's interrupt list (which can be found
on many Simtel mirrors) contains an extensive list of these numbers. You
might also want to check the network information database file which
comes with
.BR netboot .

.SS Enter PCI device ID (hex):
PCI cards have a device ID in addition to the vendor ID. It also has to
be entered as a hexadecimal number. Find out about this number using
any of the ways mentioned at the prvious question, or by using tools
provided with your network card.

.SS Select the interface you wish to use [1]:
.B netboot
knows about many different network driver interfaces. If you did not
select a known network card, it will print all known network driver
interface types, and you should select the one which fits your actual
network driver. If you selected a pre-known network card previously,
.B makerom
automatically selects the network driver interface for the driver
available. Only if it could find more than one driver for the same card
it will let you select the type which you want to use.

.SS Enter path name of [packet|NDIS|UNDI] driver ('*' for directory listing):
If you have not selected a pre-known network card, you now have to enter
the path name of your network driver binary. If you enter a star character,
.B makerom
will print a directory listing of the main network driver directory and
it's subdirectories. You can either enter a full pathname, or a non-absolute
name. In that case,
.B makerom
will search the main network driver directory and it's
subdirectories for the driver binary.

.SS Enter command line for packet driver [0x%S]:
For packet drivers you have to enter it's command line. Usually, you have
to give the software interrupt number and I/O port, memory addresses etc.
on that command line. How the command line has to look depends on the
driver you are using. The default used for the command line will be
"0x%S", with the "%S" being replaced by a default software interrupt
number selected automatically by
.BR makerom .

.SS Enter path name of PROTOCOL.INI file ('*' for directory listing):
For NDIS drivers you have to enter the pathname of a PROTOCOL.INI file.
Of course, it does not have to be named PROTOCOL.INI, but it has to
contain the necessary PROTOCOL.INI information for the network driver.
See your network driver documentation about what this file has to contain
and how it has to be written.

.SS Enter minimum execution size in bytes (-1 = default) (decimal):
This question asks about the number of bytes the network driver
will occupy once it installed itself resident. See below for a further
explanation of the
.B minsize
parameter.

.SS Enter maximum execution size in bytes (-1 = default) (decimal):
Here you can enter the number of bytes required to load the network
driver into memory. See below for a further explanation of the
.B maxsize
parameter.

.SS Do you want to use the packet driver debugger (y/n) [no] ?
When using a packet driver, it is possible to include a debugger into the
bootrom for testing purposes. This debugger will split the screen when the
bootrom starts and will then print all incoming and outgoing packets into
the lower half of the screen. This debugging feature is only useful if
you have a thorough understanding of IP networking and if you can decode
the header information printed. Otherwise, don't use the debugger.

.SS Do you want to specify an additional program (y/n) [no] ?
If you want to run some DOS program in addition to the network driver
(only available for packet and NDIS driver interfaces), you have to answer
"yes" to this question. These additional programs can, for example,
configure the network card for proper operation. For every program
you want to run in addition to the network driver you have to enter
it's command line arguments and minimum/maximum sizes like for a
packet or NDIS network driver.

.SS Should the program run before the network driver (y/n) [no] ?
If you want to run the additional program before the network driver select
"yes" here. It will then be included right before the driver in the execution
order. Otherwise it will be put at the end of the list of programs to
execute.

.SS Select the format you wish to use [1]:
.B makerom
will always produce a floppy image of the bootrom, called
.B image.flo
in the current working directory. In addition it will also create a rommable
bootrom image. At this question you can select the type of that file:
.TP
.B Raw binary
The output file will contain a raw binary of the bootrom, suitable for
burning into an EPROM with a programmer which can read raw binaries. It's
name will be
.BR image.rom .
.TP
.B Image for programming a FlashCard across the network
If you have a FlashCard installed in your client you can use this output
file type. Just start the client with an already installed bootrom or
using the floppy bootrom image, and feed it this output file as it's
boot image. The client will then automatically locate the FlashCard, and
program it with the newly created bootrom image. With this technique it's
possible to upgrade a client to a new bootrom version without opening the
system cover. The name of the flash boot image file will be
.B image.flash
in the current working directory.
.TP
.B Image for programming a flash EPROM across the network
This option lets you select an output file which can be used to program
a flash EPROM onboard a network card. It will appear only for network
cards which are supported by
.B makerom
to be programmed.
The name of the flash boot image file will be
.B image.flash
in the current working directory. As with programming a FlashCard you
can provide this file as a boot image file for the client, and it will
then try to detect the installed network card and program it's onboard
flash EPROM with the netboot bootrom.
.TP
.B Intel hex
Output file suitable for EPROM programmers which understand the Intel
hex format.
.TP
.B Motorola hex
Output file suitable for EPROM programmers which understand the
Motorola EXORmacs hex format.
.TP
.B Tektronix hex
Output file suitable for EPROM programmers which understand the
Tektronix hex format.
.LP
For all hex output formats the default output file name will be
.BR image.hex .

.SH CONFIGURATION FILE
Besides the
.SM [general]
section
.B makerom
also uses the
.SM [makerom:general]
section of the configuration file. It contains general definitions only
required by
.BR makerom .
It can contain the following parameters:
.TP
.B driverfile
Pathname of the file which contains the definitions of network driver interfaces
and network drivers. If missing, the default will be "//netboot.drivers".
.TP
.B md5sums
Pathname of the MD5 checksum database file. This file should contain the
MD5 checksums of all netwrk drivers which are currently installed. The format
of this file is the same as produced by the GNU md5sum(1) program. If the
.B md5sums
option is missing, the default will be "//netdrvr/MD5SUMS".
.TP
.B bindir
Specifies the directory where
.B makerom
can find the bootrom kernel, network driver interface and rom loader binary
files. The default is "//binaries".
.TP
.B netdrvdir
Specifies the directory where the network drivers can be found. All
non-absolute network driver pathnames are relative to the value of this
parameter. It's default value is "//netdrvr".
.TP
.B utilsdir
This parameter specifies the directory where utility files (like the
packet driver debugger) can be found. If this parameter is missing, the
default "//utils://binaries" will be used.
.TP
.B kernel32
Pathname of bootrom kernel file for 32-bit processors (e.g. 386+). The
default is "kernel.bin".
.TP
.B kernel16
Pathname of bootrom kernel for 16- and 32-bit processors. The default
is "kernel86.bin".
.TP
.B kernelm32
Pathname of bootrom kernel with old-style menu support for 32-bit
processors. It's default is "kernelm.bin".
.TP
.B kernelm16
Pathname of bootrom kernel with old-style menu support for 16- and 32-bit
processord. There is no default since
.B netboot
normally comes without such a kernel file.
.TP
.B rom32
Pathname of rom loader file for 32-bit processors. The default is "rom.bin".
.TP
.B rom16
Pathname of rom loader file for 16- and 32-bit processors. The default
is "rom86.bin".
.TP
.B floppy32
Pathname of floppy loader file for 32-bit processors. The default
is "floppy.bin".
.TP
.B floppy16
Pathname of floppy loader file for 16- and 32-bit processors. The default
is "floppy86.bin".
.LP
If a file name specified in this section of the configuration file is
not absolute, it will be treated as relative to the value of the binary
directory parameter. For example, if the
.B bindir
parameter has the value "//binaries", the main netboot directory is
"/usr/local/lib/netboot" and the
.B kernel32
parameter has the value "kernel.bin", then the resulting file name
which
.B makerom
will look up is "/usr/local/lib/netboot/binaries/kernel.bin".

.SH DATABASE FILE
The
.B makerom
sections in the database file use
[<system name>:makerom] for the tag names. They can contain the
following parameters:

.SS General bootrom parameters
.B makerom
can generate several output files in one run, all for the same client
but with different loaders. The following parameters are used for
every output file:
.TP
.B kernel
Specifies the name of the kernel file to be used. If the name starts with
two slashes these get replaced by the name of the general netboot directory.
This parameter is required.
.TP
.B bustype
Specifies the bus type of the network card on which the resulting bootrom
should run. The allowed values for this parameter are
.BR ISA ,
.BR EISA ,
.B MCA
and
.BR PCI .
If this parameter is not given,
.B ISA
will be assumed.
.TP
.B pcivendor
Specifies the PCI vendor ID used by the network card. This value can be
given as a decimal number or as a hexadecimal number if prefixed with "0x".
For example, Intel has the vendor ID "0x8086" assigned. This number will
also be used by other vendors if their network cards use an Intel chipset.
The
.B pcivendor
parameter is required for PCI network cards.
.TP
.B pcidevice
Specifies the PCI device ID used by the network card. Like the PCI vendor
ID this value can be given as a decimal or hexadecimal number. For example,
the Intel EtherExpress Pro/10 PCI network card uses "0x1226" as it's ID.
This parameter is required for PCI network cards.
.TP
.B pnpdevid
Specifies the device ID for non-PCI network cards. This parameter is
required for ISA-PnP, EISA and MCA cards. It's value has to have a
total length of 7 characters, with the first 3 characters being upper
letters and the last 4 characters being hexadecimal digits. For example,
a Intel EtherExpress 16 ISA card has been assigned an ID of "PNP812D".
.B makerom
is not able to check that this ID is correct, or even required or
suitable for the bus type selected.
.TP
.B netdrvr
Specifies the pathname of the network driver interface file to be used. If
this pathname starts with two slashes, these slashes get replaced by the
name of the main netboot directory. Otherwise, if the pathname is not
absolute, it is taken to be relative to the binaries directory as
specified in the main configuration file. This parameter is required.
.TP
.B netdrvtype
Type of network driver interface that is supported by the interface file
given with the
.B netdrvr
parameter. The allowed values are
.B packet
.BR driver ,
.B ndis driver
and
.B undi
.BR driver .
This parameter is required.

.SS Bootrom loader parameters
With these parameters it is possible to specify up to three different
output files for the same bootrom. For example, you can define output
files with different hex encoding, or one output file for burning into
a flash EPROM (using the rom loader), and another for writing onto a
floppy (using the floppy loader).
.TP
.B loaderX
Specifies the file names of all bootrom loaders.
.B makerom
will create a bootrom image file for each rom loader specified. The
.B X
in the variable name can be a number from 1 to 3. For each
.B loaderX
variable there has to be a corresponding
.B outnameX
variable as well. Normal substition for the main netboot directory will occur.
.TP
.B outnameX
Specifies the names of the bootrom image files created with the rom loaders.
For each
.B loaderX
parameter there has to be a corresponding
.B outnameX
parameter.
.TP
.B outsizeX
This specifies the size of the output file
.B outnameX
in kB.
Using this parameter, it is possible to write a smaller bootrom into a
much larger EPROM, for example to fill one EPROM with more than one
option rom image. If this parameter is missing, the size of a rom output
file will be determined so that it will fit into the smallest possible
EPROM. It will be ignored for the floppy bootrom loader.
.TP
.B outtypeX
This is an enumeration parameter which specifies the format of the
output file generated for each bootrom image given in
.BR outnameX .
The following values are recognized:
.RS
.TP
.B binary
Raw binary for programming an EPROM
.TP
.B intel hex
Bootrom image will be converted to Intel hex format for use with EPROM
programmers which require this format.
.TP
.B motorola hex
Bootrom image will be converted to Motorola EXORmacs hex format for use
with EPROM programmers which require this format.
.TP
.B tektronix hex
Bootrom image will be converted to Tektronix hex format for use
with EPROM programmers which require this format.
.TP
.B flash
The bootrom image will be prepended by a special boot loader which allows
it to be booted using a bootrom. It will then program a FlashCard
with the new bootrom image. This method can be used to easily update the
bootrom in a diskless client without unmounting the cover. It doesn't
make sense to use this output type with the floppy boot loader.
Therefore, the
.B loaderX
parameter has to specify a rom loader when using the
.B flash
output file type.
.B makerom
will not check for this condition.
.RE
.TP
.B ldoptsX
Specify options for
.BR loaderX .
By default, all options are
.B false
unless explicitely specified with this parameter. All option names are
seperated by a comma and have to be given in all lower case. Their order
within the parameter argument string doesn't matter. The following options
are available:
.RS
.TP
.B useint18
If this option is given, the bootrom will use interrupt 18h for startup which
is the BASIC startup vector on old PC's. This interrupt gets called by the
BIOS when it can't find a bootable floppy or hard disk partition. If this
option is not given,
the bootrom will use interrupt 19h instead, which is the PC bootstrap
interrupt. In this case, the system will not seek any hard disks in the
system for a bootable partition (but will still check the first floppy
drive), but immediately start the netboot process.
.TP
.B cardinst
This option specifies that the bootrom will be installed directly on the
network card. If this option is not given,
the PCI header gets removed from the bootrom image (actually, only the
pointer to this header will be set to zero). Otherwise, some BIOSes might
get confused to find a PCI header not being within a ROM installed on a PCI
card.
.TP
.B bootask
If this option is given,
the bootrom will ask the user if it should continue with the network boot
process or not upon startup.
.TP
.B asktime
This option should be followed by an equal sign and a number between 0 and
31. It specifies the time the bootrom will wait for a user to press a key
when the
.B bootask
option (see above) is specified. A value of 0 means to wait forever. It is
the default. If the
.B bootask
option is not given, the
.B asktime
option has no effect.
.RE

.SS Packet driver parameters
These parameters are only used with the packet driver interface.
.TP
.B pktdrvidx
Specifies the index number of the packet driver in the list of programs
to load (see below).
.TP
.B pdprogX
Specifies the file names of programs to be loaded by the bootrom, including
the packet driver. The
.B X
in the parameter name can be a number from 0 to 7. For each
.B pdprogX
parameter there has to be a corresponding
.B pdargsX
parameter as well. If the file name is not absolute it will be treated
as relative to the utilities directory except for the packet driver
itself (identified by the
.B pktdrvidx
parameter), which is relative to the network driver directory.
.TP
.B pdargsX
Command line arguments for program
.BR pdprogX .
.TP
.B pdminsizeX
Specifies the run-time size of program
.B pdprogX
in bytes.
.TP
.B pdmaxsizeX
Specifies the load size of program
.B pdprogX
in bytes.

.SS NDIS driver parameters
These parameters are only used with the NDIS driver interface.
.TP
.B protini
Specifies the pathname of a protocol.ini file, which will be parsed by
.BR makerom .
The bootrom will later use the parsed protocol.ini file to simulate a
protocol manager to the NDIS driver. The protocol.ini file has to have
at least the entry for the NDIS driver used by the bootrom. This entry
has to have at least a
.SM drivername
specification, which has to be set according to what the NDIS driver
expects. Typical protocol.ini files for your NDIS driver can usually
be found at the same place where you got your driver binary. For a further
explanation of the format of the protocol.ini file see the
.B netboot
documentation.
.TP
.B ndisdrvidx
Specifies the index number of the NDIS driver in the list of programs
to load (see below).
.TP
.B ndprogX
Specifies the file names of programs to be loaded by the bootrom including
the NDIS driver. The
.B X
in the parameter name can be a number from 0 to 7. For each
.B ndprogX
parameter there has to be a corresponding
.B ndargsX
parameter as well. If the file name is not absolute it will be treated
as relative to the utilities directory, except for the NDIS driver
(identified by the
.B ndisdrvidx
parameter), which is relative to the network driver directory.
.TP
.B ndargsX
Command line arguments for program
.BR ndprogX .
.TP
.B ndminsizeX
Specifies the run-time size of program
.B ndprogX
in bytes.
.TP
.B ndmaxsizeX
Specifies the load size of program
.B ndprogX
in bytes.

.SS UNDI driver parameters
These parameters are only used with the UNDI driver interface.
.TP
.B undiprog
Specifies the file name of the UNDI driver binary. If it's not absolute it
will be treated as relative to the directory specified by the
.B netdrvr
parameter in the main configuration file.

.SS minsize and maxsize parameters
All DOS file parameters (those used with the packet and NDIS driver interfaces)
use minsize and maxsize parameters. With these parameters it is possible to
optimize the memory usage of the bootrom, especially when programs get loaded
in addition to the network driver binary. All these parameters are optional,
and if any of them is missing,
.B makerom
tries to find a suitable default value.
.TP
.B minsize
Such a parameter specifies the run-time size of the program or network driver
in bytes. If a program terminates normally, it's
.B minsize
value is zero. Only if the program or driver stays resident in memory, the
.B minsize
value should be larger than zero. You can determine it by running the program
under plain DOS, and then inspect the memory usage using the "mem /c" command.
Add 1024 bytes for the PSP and for a safety margin to the number of bytes
printed by the mem command.
.TP
.B maxsize
This parameter specifies the number of bytes to allocate in order to be
able to load the program or driver. For EXE type programs it should not be
necessary to specify this parameter since
.B makerom
can determine their memory requirements by using the file header. However,
COM type programs are a bit more difficult. Usually it should be sufficient
to take the size of the program or driver binary file, and add some amount
of say 4096 bytes for PSP and stack in order to determine the
.B maxsize
parameter value. The actual amount of memory required might be different
due to different stack requirements, but 4096 is probably a good stack
size assumption. If this parameter is not given,
.B makerom
will assume a stacksize requirement of 1024 bytes by default. If this is
too small (for example your program or network driver crashes when getting
started by the bootrom), you have to use a larger
.B maxsize
parameter. Especially, when the COM type program has been compressed (for
example with PKLITE, a popular executable compressor) this assumption might
be wrong and a larger
.B maxsize
value has to be used.
.LP
Since
.B minsize
gives the runtime size of a network driver, it's value should only be
smaller than
.B maxsize
if the driver really shrinks after getting loaded. Sometimes, a network
driver increases in size because it has to allocate some internal buffer
memory. In this case,
.B minsize
should have the same value as
.BR maxsize .
Since
.B makerom
is unable to detect such a condition, you should NOT let it assume default
values in this case, but specify the sizes correctly.

.SH NETWORK DRIVER INFORMATION FILE
The Driver Information File (DIF for short) contains definitions for all
network driver interface files. It also contains definitions for a large
number of different pre-known network drivers. Note that not all network
drivers named in the DIF distributed with
.B netboot
are also included in this package. In fact, most of the drivers mentioned
in the DIF are manufacturer provided network drivers, which can usually be
found on the driver disks shipped with a network card, or on the FTP or
HTML servers of the manufacturers. For a listing of some network card
manufacturers see the netboot home page on http://netboot.sourceforge.net.
It also contains direct links to some pages where you can find the latest
drivers.

.SS Network driver interface file definitions
For each network card, the
.B netboot
bootrom does not only require a network driver, but also an interface
file for that driver. Currently, files are provided for the following
interfaces: packet driver, NDIS driver and UNDI driver. For each
interface a seperate section has to be specified in the DIF. The
sections are named
.B [netdrv:<interface>]
with the interface name being one of
.BR pktdrv ,
.B ndis
or
.BR undi .
Note that like with all other configuration files these names have to
be given all lower case. Each section can have the following parameters:
.TP
.B description
This parameter specifies a description string for the interface. This
string will be printed in interactive mode, when more than one interface
is available for a certain network card.
.TP
.B filename32
Specifies the name of the 32-bit binary file for the interface. If this
file name is not absolute, it will be assumed to be relative to the
binary directory as specified in the main configuration file.
.TP
.B filename16
The name of the 16-bit binary file for the interface.
.TP
.B directory
Specifies the directory or colon seperated directories where network drivers
can be found for the interface.
.TP
.B pattern
When printing a listing of the directories specified with the
.B directory
parameter, only those files will be printed which match the given patterns.
All patterns in the value to this parameter have to be seperated by colons.
These patterns are like the simple command line patterns used by the shell,
instead of regular expressions. A star character serves as a wildcard.

.SS Network card descriptions
A network card description contains parameters which describe the hardware
and are common for all drivers for a certain NIC. The section names are
constructed as
.B [card:<nicname>]
where <nicname> specifies a unique name for a network card. Each NIC name
has to appear only once in the DIF. A network card section can contain the
following parameters:
.TP
.B description
This parameter specifies a description text for the network card. It will
be printed in interactive mode in the listing of supported network cards.
.TP
.B bustype
Specifies the host bus type of the network card. If a card gets manufactured
with different bus types, a seperate section with a distinct <nicname> has to
be written for each type. This parameter can have one of the following values:
.BR ISA ,
.BR EISA ,
.B MCA
and
.BR PCI .
.TP
.B pcivendor
If this NIC is a PCI card, then this parameter specifies the PCI vendor
ID. It has to be a numerical value, and can be given in hex if prefixed
by "0x".
.TP
.B pcidevice
Specifies the PCI device ID. This parameter also has to be numerical.
.TP
.B pnpdevid
Specifies the PNP device ID, which is a string of 7 characters. The first
3 characters have to be upper case letters, and the last 4 characters have
to be hexadecimal digits. This parameter is required if the NIC is a
ISA/PnP, EISA or MCA card. However,
.B makerom
is not able to check if this parameter really is required or suitable for
the card or bus type selected.
.TP
.B usedriver
If no network driver has been specified for this NIC, then it is possible
to use the network driver descriptions of a different NIC using this
parameter. It specifies the <nicname> of that network card whose driver
descriptions should be used. If this parameter is used, no network driver
description is allowed to be specified for this NIC. Also the card description
this parameter refers to is not allowed to also use the
.B usedriver
parameter.

.SS Network driver descriptions
Following a network card description there can be one or more network
driver description sections. Each such section has to have a name of
.B [driver:<nicname>]
with <nicname> being the same as that for the card description it belongs
to. Each driver description section can have the following parameters:
.TP
.B driverdesc
Specifies a desrciptive string for the driver. This string will be printed
in interactive mode if more than one driver for a selected network card
has been found.
.TP
.B drvtype
Specifies the interface type supported for this driver. This enumeration
parameter can have one of the following values:
.B packet
.BR driver ,
.B ndis driver
and
.B undi
.BR driver .
.B makerom
will select the proper interface binary file according to this parameter.
.TP
.B file
File name of the network driver binary. If this file name is not absolute,
it will be looked up by using the search directory path specified in the
interface description relevant for this network driver.
.TP
.B params
Specifies the hardware parameters which
.B makerom
should ask the user about in interactive mode. This parameter is required
when wildcards are used with
.B cmdline
and
.B protini
as described below. All parameter values have to be seperated by commas.
The following values are known:
.RS
.TP
.B HW_IRQ
Hardware IRQ number
.TP
.B IO_ADDR
I/O port address
.TP
.B BASE_MEM
Base memory segment for shared RAM
.TP
.B AUI_TYPE
Type of network connector to be used
.TP
.B DMA_NUM
DMA channel number
.LP
Note that in contrast to all other enumeration values used with the netboot
configuration files, these parameter values are all upper case.
.RE
.TP
.B cmdline
For packet drivers, a command line is required. This parameter specifies the
string to be used for it. This string can contain wildcards
for certain values:
.RS
.TP
.B %S, %s
Gets replaced by the default software packet driver interrupt number. This
number is fixed and can't be changed.
.TP
.B %H, %h
Gets replaced by the hardware interrupt number as entered by the user.
.TP
.B %A, %a
Gets replaced by the I/O port address as entered by the user.
.TP
.B %M, %m
Gets replaced by the base memory segment as entered by the user.
.TP
.B %D, %d
Gets replaced by the DMA channel number as entered by the user.
.TP
.B %t
Gets replaced by the AUI type number as entered by the user.
.LP
Upper case wildcards get replaced by a hexadecimal number, while lower case
wildcards get replaced by a decimal number. All wildcards used within the
command line string (except the %S and %s wildcards which are fixed) have
to be specified with the
.B params
parameter as described above. Otherwise, their value will not be asked
for in interactive mode, and the resulting command line will get
unpredictable substitutions.
.RE
.TP
.B protini
NDIS drivers require a so called protocol manager, which in turn reads a
protocol.ini file. The
.B netboot
bootrom simulates this mechanism, but still requires the protocol.ini
file contents which is relevant for the NDIS driver. This parameter
can specify an actual file name.
.B makerom
then reads that file as a protocol.ini file. Of course it doesn't have to
be named protocol.ini but can have any name you like. Alternatively, the
.B protini
parameter can contain a string value which is treated as the contents of
a protocol.ini file relevant for the NDIS driver. Since such a file contents
usually requires newlines, this string should best be enclosed in double
quotes. It can then be spread across multiple lines. All newlines between
the double quotes get copied into the string verbatim. A protocol.ini file
contents (either given as a string or by reading an actual protocol.ini
file) can use the same wildcards as a packet driver command line. See above
for a further explanation of these wildcards.
.TP
.B md5sum
Specifies the MD5 checksum of the network driver binary. Using this
paramater it is possible to specifiy different driver information
records for different versions of a network driver. If the
.B md5sum
parameter is missing,
.B makerom
will use this record whenever it is unable to find the network
driver file name in the MD5 checksum database file specified in the
configuration file or on the command line with the
.B \-m
command line option. However, if an MD5 checksum has been specified
with the
.B md5sum
parameter, this record will only be used when the file name has been
found in the MD5 database file, and both checksum values match.
.TP
.B minsize
Specifies the runtime size of the network driver in bytes. See above
for a further explanation of the
.B minsize
parameter.
.TP
.B maxsize
Specifies the required number of bytes to load the driver into memory. See
above for a further explanation of the
.B maxsize
parameter.

.SH COMPRESSED NETWORK DRIVERS
Some network drivers (especially packet drivers) get compressed by the
manufacturer. They will decompress themselves when started. This
decompression requires a lot of memory. For EXE type programs, the
memory requirement should be encoded into the EXE file header. However,
for COM programs there is no such header.
.B makerom
tries to identify compressed programs. Currently, it only knows about
the PKLITE compressor. All other runtime compressors (like LZEXE or
TINYPROG) convert COM type programs into EXE files, which have the
above mentioned header. When
.B makerom
finds a compressed program it tries to find out how much memory will
be required. Unfortunately, at least all PKLITE versions I found have
a bug in the compressor which results in an incorrect specification
about how much memory is required for the decompression.
.B makerom
can only rudimentarily check for this condition, and will print a
warning in this case. It will then use a hopefully safe default.
Even when
.B makerom
does not print this warning, the bootrom might fail on the compressed
executable.
Therefore, whenever you experience problems running the network driver
either in it's startup phase or during bootrom operation, you should
check if it has been compressed, and decompress it manually if
possible. Programs to do so can be found on many DOS software FTP
sites, like ftp.simtel.net. It doesn't make sense to use compressed
executables anyway, since the final bootrom gets compressed by
.B makerom
also.

.SH PROTOCOL.INI FILES
NDIS drivers require a so called protocol manager which gets simulated
by the NDIS interface binary. However, this simulator needs a protocol.ini
file like a real protocol manager.
.B makerom
parses this protocol.ini file and converts it into a format suitable for
the bootrom. The contents of this protocol.ini file has to follow the
same rules as layed out in the NDIS specification, published by Microsoft
and 3Com. In general, a protocol.ini file is divided into sections like
all netboot configuration files. Each section has to start with a name
enclosed in square brackets. Usually, the protocol.ini file used for
a bootrom only requires one section for the network driver. All other
sections usually found in a DOS protocol.ini file are not required and
just increase the size of the bootrom. Especially, it's not necessary
to specify a section for the protocol manager.
.B makerom
is presently unable to remove those unused sections, so you should not
specify them in the first place. Comments in a protocol.ini file are
preceded by a semicolon, and will be removed by
.B makerom
internally, so that they don't take up any space in the final bootrom.
.LP
Like all netboot configuration files, each section of a protocol.ini
file contains several parameters, with each parameter on a seperate
line. However, in contrast to the netboot configuration files a
protocol.ini file is parsed case-independent. All text in the file
gets converted to upper case. A NDIS driver section has to contain at
least the
.B drivername
parameter, followed by an equal sign and the driver name required by
the NDIS driver. This name has to be exactly that expected by the driver.
You can usually find it in the documentation of the network driver. It
commonly ends with a dollar sign. Other parameters might be necessary
depending on the driver. Common parameters include:
.BR iobase ,
.B ramaddress
and
.BR irq .
It is also usually possible to define many other parameters for a
network driver, like specifying the number of transmit or receive
buffers etc. Please note that when changing these numbers from within
a protocol.ini file, the memory requirement of a NDIS driver might
change and might require different minsize/maxsize values. For
a further description of any additional NDIS driver protocol.ini
parameters refer to the documentation which comes with your driver.

.SH FILES
For all files mentioned below the physical path might differ according
to the configuration of
.BR makerom .
See the netboot(5) man page for a further explanation of these files.
.TP
.B /usr/local/etc/netboot.config
Main netboot configuration file.
.TP
.B //netboot.drivers
Network driver information file, which contains information about
various network driver interfaces and network driver binaries.
.TP
.B //netdrvr/MD5SUMS
Network driver MD5 checksum database.
.TP
.B //netboot.db
Default database file for specifying system configurations.
.TP
.B //binaries/kernel.bin
Standard 32-bit bootrom kernel
.TP
.B //binaries/kernel86.bin
16-bit bootrom kernel
.TP
.B //binaries/kernelm.bin
32-bit bootrom kernel with old menu suport
.TP
.B //binaries/floppy.bin
32-bit floppy bootrom loader
.TP
.B //binaries/floppy86.bin
16-bit floppy bootrom loader
.TP
.B //binaries/rom.bin
32-bit bootrom loader
.TP
.B //binaries/rom86.bin
16-bit bootrom loader
.TP
.B //binaries/netpkt.bin
32-bit packet driver interface file
.TP
.B //binaries/netpkt86.bin
16-bit packet driver interface file
.TP
.B //binaries/netndis.bin
32-bit NDIS driver interface file
.TP
.B //binaries/netndis86.bin
16-bit NDIS driver interface file
.TP
.B //binaries/netundi.bin
32-bit UNDI driver interface file
.TP
.B //binaries/netundi86.bin
16-bit UNDIdriver interface file
.TP
.B //utils/pktwatch.com
Packet driver debugger
.TP
.B //netdrvr/pktdrvr/*
Packet driver executables
.TP
.B //netdrvr/ndis/*
NDIS driver executables
.TP
.B //netdrvr/undi/*
UNDI driver executables

.SH ENVIRONMENT VARIABLES
All
.B netboot
programs use these environment variables as a last resort when the
corresponding configuration file parameters or command line options
are not given. If an environment variable is specified it will override
the compiled-in default.
.TP
.B NETBOOT
Specifies the main
.B netboot
directory. This environment variable setting can be overriden by the
.B \-N
or
.B \-\-netboot-dir
command line options or by the
.B netbootdir
configuration file entry.
.TP
.B NETBOOT_CONFIG
Specifies the name of the configuration file. This environment variable
setting can be overriden by the
.B \-c
or
.B \-\-config-file
command line options.
.TP
.B NETBOOT_DATABASE
Specifies the name of the system database file to be used with the
.B \-b
or
.B \-\-batch\-sys
command line options. This is environment variable setting can be
overriden by the
.B \-D
or
.B \-\-database\-file
command line options or the
.B database
configuration file entry.

.SH BUGS
None known yet.

.SH SEE ALSO
netboot(5), netboot.config(5), netboot.drivers(5)

.SH AUTHOR
.B makerom
was written by
.SM Gero Kuhlmann <gero@gkminix.han.de>.

